%{
// filename: scanner.l
#include "parser.h"
#include <string.h>
#include <math.h>

extern void yyerror(const char * message);
#define ECHO fwrite( yytext, yyleng, 1, yyout )

%}

%option noyywrap
EXP ([Ee][-+]?[0-9]+)

%%

"{" { return LCURLY; }
"}" { return RCURLY; }
"[" { return LBRAC; }
"]" { return RBRAC; }
"," { return COMMA; }
":" { return COLON; }
"true" { return VTRUE; }
"false" { return VFALSE; }
"null" { return VNULL; }
[ \t\r\n]+ { /* eat whitespace */ }
\"[^"]*\" { yylval.string = strdup(yytext); return STRING; }
[1-9]+"."?[0-9]*{EXP}? {
  float f = atof(yytext);
  if (ceilf(f) == f) {
    yylval.integer = atoi(yytext);
    return NUMBER_INTEGER;
  } else {
    yylval.decimal = f;
    return NUMBER_FLOAT;
  }
}

%%
